//    Coobird's Data Viewing and Selecting Program with Integration (Dvaspi)
//    Copyright (C) 2008 Chris Kroells
//
//    This file is part of Dvaspi.
//
//    Dvaspi is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    Dvapsi is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Dvaspi.  If not, see <http://www.gnu.org/licenses/>.


package net.coobird.dvaspi;

import java.util.*;

/**
 * The MessageEvent class is the means for sending messages across
 * Dvaspi components. In particular, the event has an action and message, where
 * generally the message is used as the text to display in a message box to
 * notify the user of an error message, etc.
 * @author coobird
 *
 */
@SuppressWarnings("serial")
public class MessageEvent extends EventObject 
{
	private String msg;
	private String action;
	
	public MessageEvent(Object source, String action, String msg)
	{
		super(source);
		this.msg = msg;
		this.action = action;
	}
	
	public String getMessage()
	{
		return msg;
	}

	public String getAction()
	{
		return action;
	}
}
