//    Coobird's Data Viewing and Selecting Program with Integration (Dvaspi)
//    Copyright (C) 2008 Chris Kroells
//
//    This file is part of Dvaspi.
//
//    Dvaspi is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    Dvapsi is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Dvaspi.  If not, see <http://www.gnu.org/licenses/>.


package net.coobird.dvaspi;

/**
 * An array that wraps around when an index beyond the size of the array.
 * @author coobird
 * @param <T> Type of the data being held by the array.
 * 
 */
public class WrapArray<T>
{
	private T[] array;
	private int numElements = 0;
	private int counter = 0;
	
	@SuppressWarnings("unchecked")
	public void add(T element)
	{
		T[] temp = (T[])new Object[numElements + 1];
		
		if (array != null)
			for (int i = 0; i < array.length; i++)
				temp[i] = array[i];
		
		temp[numElements] = element;
		
		array = (T[])new Object[numElements + 1];
		
		System.arraycopy(temp, 0, array, 0, temp.length);
		
		numElements++;
	}
	
	public T getElement(int i)
	{
		counter %= numElements;
		int element = i % numElements;
		return (T)array[element];
	}
	
	public T getNextElement()
	{
		return (T)getElement(counter++);
	}
}
